package com.gxzc.zen.orm.data.authority

/**
 * 数据权限 构建器
 * @author NorthLan
 * @date 2018/7/25
 * @url https://noahlan.com
 */
open class DataAuthorityBuilder {
    private val da: DataAuthority = DataAuthority()

    fun createByList(createByList: String): DataAuthorityBuilder {
        da.createByList = createByList
        configBizDA()
        return this
    }

    fun createByList(createByList: Collection<String>): DataAuthorityBuilder {
        da.createByList = createByList.joinToString(",")
        configBizDA()
        return this
    }

    fun systemDA(enabled: Boolean): DataAuthorityBuilder {
        da.sysDAEnabled = enabled
        return this
    }

    fun bizDA(enabled: Boolean): DataAuthorityBuilder {
        da.bizDAEnabled = enabled
        return this
    }

    fun build(): DataAuthority {
        return da
    }

    private fun configBizDA() {
        if (!da.createByList.isNullOrEmpty()) {
            da.bizDAEnabled = true
        }
    }
}